package com.example;

import akka.actor.typed.ActorRef;
import akka.actor.typed.Behavior;
import akka.actor.typed.javadsl.*;

public class AkkaMainSystem extends AbstractBehavior<AkkaMainSystem.Create> {

    public static class Create {
    }

    public static Behavior<Create> create() {
        return Behaviors.setup(AkkaMainSystem::new);
    }

    private AkkaMainSystem(ActorContext<Create> context) {
        super(context);
    }

    @Override
    public Receive<Create> createReceive() {
        return newReceiveBuilder().onMessage(Create.class, this::onCreate).build();
    }

    private Behavior<Create> onCreate(Create command) {
        //#create-actors
        ActorRef<Queue.Message> queue = this.getContext().spawn(Queue.create(), "queue");
        ActorRef<Producer.Message> producer = this.getContext().spawn(Producer.create(queue), "producer");
        ActorRef<ConsumerFactory.Message> cFactory = this.getContext().spawn(ConsumerFactory.create(queue), "cFactory");
        //#create-actors

        producer.tell(new Producer.Start(90));
        cFactory.tell(new ConsumerFactory.Start(100));
        return this;
    }
}
